--declare('LK', {})
LK = {}
--  Used to issue and revoke keys.  From the chat line /keys
--	Only works off your current owner keys, so if you have no
-- 	owner keys, it really doesn't do anything except manage the
--	keys you have.
--	If you have a capship, then it will also issue or revoke 
--	that key as well as station keys.
--  The nokeys list is excluded from distrubution. 
--  Updated to use a server stored user list.
--	
--	Thanks,
--	Lisa201

LK.junk = {}  -- Junk variablet to use for testing.
LK.Binds = {} -- Place to keep binds from the data file.
LK.version 	= '4.11'
dofile("vars.lua")  -- Variables
-------------------------------------------------------
dofile("http.lua")  -- This section written by UnCopan Thanks UnCopan!!
dofile("tcpsock.lua") -- Access to a mysql database
dofile("ui.lua") -- User interface 
dofile("systems.lua") -- Load faction and system names table.

LK.ui = dofile'ui.lua'

function LK.Server_Callback(not_ok, header, LK_page)
  if not_ok then
  	LK.msg(LK_White,"ERROR1: "..not_ok)
  else
    if header.status == 200 then --Process what came back
				LK_srvdata	= {}
  		for token in string.gmatch(LK_page, "[^\n]+") do --Convert to table
  			if token ~= "\r" then table.insert(LK_srvdata,token) end
			end   
  	else
			if header.status then
    		LK.msg(LK_White,"ERROR2: HTTP Error "..header.status)
			end
  	end --Process what came back
 	end
	
	if (LK_srvdata[1] == "listkeys") then
		LK.Users = {}  -- Code to get the results into the user list.
		for k,j in pairs(LK_srvdata) do -- Put the list of users in the table.
			if (k > 1) then table.insert(LK.Users,j) end
		end
		LK.Users_loaded = true
		return
	end
	
	if (LK_srvdata[1] == "listown") then
		LK.Owners = {}  -- Code to get the results into the owner list.
		for k,j in pairs(LK_srvdata) do -- Put the list of owners in the table.
			if (k > 1) then table.insert(LK.Owners,j) end
		end
		LK.Owners_loaded	= true
		return
	end
	
	if (LK_srvdata[1] == "listcmds") then
		LK.Cmds = {}  -- Code to get the results into the owner list.
		for k,j in pairs(LK_srvdata) do -- Put the list of owners in the table.
			if (k > 1) then table.insert(LK.Cmds,j) end
		end
		LK.ListToDo()
		return
	end
	
	if (LK_srvdata[1] == "listnokeys") or (LK_srvdata[1] == "listnokeys")then
		LK.NoKeys = {}  -- Code to get the results into the Bad Key list.
		for k,j in pairs(LK_srvdata) do -- Put the list of Bad Key in the table.
			if (k > 1) then table.insert(LK.NoKeys,j) end
		end
		LK.NoKeys_loaded	= true
		return
	end
	
--	LK.msg(LK_Grey,LK_srvdata[1].." Completed.")
-- 	if (LK_srvdata[1] == "addnokey") then LK.msg(LK_Grey,"Key added to No Key list") end
-- 	if (LK_srvdata[1] == "adduser") then LK.msg(LK_Grey,"User Added") end
-- 	if (LK_srvdata[1] == "addown") then LK.msg(LK_Grey,"Owner Added") end
-- 	if (LK_srvdata[1] == "addcmd") then LK.msg(LK_Grey,"Command Added") end
-- 	if (LK_srvdata[1] == "remnokey") then LK.msg(LK_Grey,"NoKey list updated") end
end

-- Talk to the server---------------------------------------------
function LK.Server_Command(data, args)
	args[2] = args[2] or "none"
	args[3] = args[3] or LK.version
	LK.PlayerName	= string.lower(GetPlayerName(GetCharacterID()))
	K_HTTP.urlopen('http://tgft.noip.me/vendetta/voproxy2.php', 'POST',LK.Server_Callback, {user=string.lower(LK.PlayerName),passwd=LK.password,command=args[1],param1=string.lower(args[2]),param2=args[3]})
end

-- Msg the user --------------------------------------------------
function LK.msg(color,msg)
	if (msg) then print(color .. msg) end
end

-- Toggle debug the user --------------------------------------------------
function LK.debugtoggle()
	if LK.debug then 
		LK.debug = false
		LK.msg(LK_White,"Debug is now OFF")
	else
		LK.debug = true
		LK.msg(LK_White,"Debug is now ON")
	end
end

-- key call-back function -------------------------------
function LK.Callback(err,result)
if err then 
	if not (result == "That player already has that key.") then
		LK.msg(LK_White,"Result: "..result)
		end
	end
end

-- Get Keys -------------------------------
function LK.Get_Keys() -- From the users keychain
LK.num_keys = GetNumKeysInKeychain();
LK.keys = {}
for v = 1, LK.num_keys, 1 do
		LK_keyid, LK_description, LK_owner, LK_timestamp, LK_access, LK_possessors, LK_active = GetKeyInfo(tonumber(v))
		if LK_active then 
			LK.KeyData(LK_keyid,LK.Callback)
		end
		local LK_key_data = {ID = LK_keyid, DESC = LK_description, OWN = LK_owner, ACTIVE = LK_active, ACCESS = LK_access, POSS = LK_possessors }
		table.insert(LK.keys,LK_key_data)
	end
LK.Keys_loaded = true
end

-- List Keys --------------------------------------
function LK.Show_Keys(x)
	local myoutput = ""
	local line = ""
	local color
	for i = 1, LK.num_keys, 1 do 
	local LK_key_data = LK.keys[i]
	color = LK_Red -- Default color for in-active keys.
	line = i..": "..LK_key_data.ID .. " <" .. LK_key_data.DESC  .. ">  " 
	line = LK_key_data.ID .. " <" .. LK_key_data.DESC  .. ">  " 
	if LK_key_data.ACTIVE then 
		line = line .. "ACTIVE "
		color = LK_Grey  
		end
	if not LK_key_data.OWN then 
		line = line .. "OWNER KEY " 
		if LK_key_data.ACTIVE then color = LK_White end
		end
	if (x == 0) then -- Show ALL the keys
		--LK.msg(color,line) 
		myoutput = myoutput..color..line.."\n"
	elseif (x ==1) and ((LK_key_data.ACTIVE) and (LK_key_data.OWN))  then -- Just the user keys please
		--LK.msg(color,line)
		myoutput = myoutput..color..line.."\n"
	elseif (x ==2) and ((LK_key_data.ACTIVE) and (not LK_key_data.OWN))  then -- Just the owner keys please
		--LK.msg(color,line)
		myoutput = myoutput..color..line.."\n"
		end
	end
	LK.ui:ShowOutput(myoutput)
end

-- Do I have Key --------------------------------------
function LK.IHaveKey(x)
	x = tostring(x)
	for i = 1, LK.num_keys, 1 do 
	local LK_key_data = LK.keys[i]
	if (LK_key_data.ID == x) then return true end
	end
return false
end

-- Get a keys index number --------------------------------------
function LK.GetKeyIndex(x)
	for i = 1, GetNumKeysInKeychain(), 1 do 
		LK_keyid, LK_description, LK_owner, LK_timestamp, LK_access, LK_possessors, LK_active = GetKeyInfo(tonumber(i))
		if (tonumber(LK_keyid) == tonumber(x)) then return i end
	end
return -1 -- Not found in the list 
end

-- Purge Old User Keys --------------------------------------
function LK.Purge()
	for i = 1, LK.num_keys, 1 do 
		local LK_key_data = LK.keys[i]
		local color = LK_Red -- Default color for in-active keys.
		local line = LK_key_data.ID .. " <" .. LK_key_data.DESC  .. ">  " 
		if (not LK_key_data.ACTIVE) and (LK_key_data.OWN) and not LK.IHaveKey(LK_key_data.OWN) then 
			-- Just the user keys please
			LK.Deletekey(LK_key_data.ID)
		end
	end
end

-- Verify Key when you enter systems -----------------------------------------------
function LK.Key_Verified()
	local destsector = NavRoute.GetNextHop()
	--LK.msg(LK_White,"XXNext Destination Sector: ".. destsector)
	local stationname = "None"
	if destsector==4019 then stationname = "Pelatus Mining Station" end
	if destsector==4317 then stationname = "Bractus IX Planetary Outpost" end
	if destsector==5753 then stationname = "CONQUERABLE STATION" end
	--LK.Timer3:SetTimeout(1000,LK.Sector_Verified) -- 1 sec later load owner keys
	LK.Sector_Verified()
	if stationname == "None" then return end -- Normal sectors... just return
	
local keyvalid = false
for i = 1, LK.num_keys, 1 do 
		local LK_key_data = LK.keys[i]
		if LK_key_data.ACTIVE then
			LK.Key = LK_key_data.ID
			local i = LK.GetKeyIndex(LK.Key)
			LK_keyid, LK_description, LK_owner, LK_timestamp, LK_access, LK_possessors, LK_active = GetKeyInfo(tonumber(i))
			if not LK_access then break end -- No access on this key
			for j = 1, # LK_access, 1 do 
				if not LK_owner then break end -- Don't check the owner keys.
				if (LK_access[j][1].name==stationname) then
					--print("Station Name is: "..stationname)
					--print("Key number "..i)
					--if (LK_access[j][2].iff) then print("IFF") else print("NOT  IFF") end
					--if (LK_access[j][2].candock) then print("DOCK") else print("NOT  DOCK") end
					if (LK_access[j][2].candock) and (LK_access[j][2].iff)then 
						keyvalid = true 
						break
					end
--					if (LK_access[j][2].iff) then keyvalid = true end
				end
			end
		end 
	end
	if not keyvalid then LK.msg(LK_Red,"-- WARNING -- Key is NOT VALID! "..stationname) end
end 

-- Verify faction standing before jumping to systems ---------------
function LK.Sector_Verified()
	local destsector = NavRoute.GetNextHop()
	if not destsector then 
		LK.Timer1:SetTimeout(4000,LK.Sector_Verified) -- 4 sec later load owner keys
		--print("delay running...")
		return
	end
	--print("Dest Sector is: "..destsector)
	local charidis = GetCharacterID()
	local systemid = GetSystemID(destsector)
	local sys = LK.System_Names[systemid][1]
	local name = LK.System_Names[systemid][2]
	local sectfaction = LK.System_Names[systemid][3]
	local destfaction = GetPlayerFactionStanding(sectfaction, charidis) / 32.768 -1000
	if destfaction < -599 then
		LK.msg(LK_Red,"-- WARNING -- Faction Standing at Destination! ")
	end
end

	-- Show Keys status -----------------------------------------------
function LK.Key_Status()
	local valid_keys = 0
	LK.msg(LK_Grey,"Curret Key Status:")
	for i = 1, LK.num_keys, 1 do 
		if LK.debug then print("ks 1: "..LK.num_keys) end 
		local LK_key_data = LK.keys[i]
		if LK_key_data.ACTIVE then
			if LK.debug then print("ks Active key") end
			LK.Key = LK_key_data.ID
			local i = LK.GetKeyIndex(LK.Key)
			LK_keyid, LK_description, LK_owner, LK_timestamp, LK_access, LK_possessors, LK_active = GetKeyInfo(tonumber(i))
			--if not LK_access then print("No access on key. "..LK.Key) return end
			if not LK_access then break end
			for j = 1, # LK_access, 1 do 
				local GoodKey = true
				local msg = LK.Key.."   "..LK_access[j][1].name.." - "..LK_description.." - "
				if LK_access[j][2].candock then
					msg = msg .. LK_Green 
				else 
					msg = msg .. LK_Red 
					GoodKey = false
				end
				msg = msg .."Dock - "
				
				if LK_access[j][2].iff then 
					msg = msg .. LK_Green 
				else 
					msg = msg .. LK_Red 
					GoodKey = false
				end
				msg = msg .."IFF"
				if LK.IHaveKey(tostring(LK_key_data.OWN)) then
					msg = msg .. LK_Green .." - Owner"
				end

				if LK.debug then print("ks 4: ".. (LK_owner or "Empty")) end
				if LK_owner and not string.find(LK_access[j][1].name, "Capship") then
					valid_keys = valid_keys +1
					if GoodKey then LK.msg(LK_Green,msg)
					if LK.debug then print("ks Good Key") end
				else
					if LK.debug then print("ks BAD Key") end
					LK.msg(LK_Yellow,msg)
					end
				end
			end
		end 
	end
-- 	if valid_keys < 3 then 
-- 		SendChat("#giveall", "PRIVATE", "IRC_")
-- 	end
	--	print("Valid key count is: "..valid_keys)
end 

-- Person in user list?-----------------------------------------
function LK.InUserList(towho)
	for k,j in pairs(LK.Users) do
		if (j == towho) then return true end
	end
	return false;
end

-- Person in Owner list?-----------------------------------------
function LK.InOwnerList(towho)
	for k,j in pairs(LK.Owners) do 
		if (j == towho) then return true end
	end
	return false;
end

-- Key in Bad_key list?-----------------------------------------
function LK.InNoKeyList(keynum)
	for k,j in pairs(LK.NoKeys) do 
		if (j == keynum) then return true end
	end
	return false;
end

-- Give User keys -------------------------------------------------
function LK.Give_User(towho)
	towho = string.lower(towho)
	local found = 0
	for i = 1, # LK.keys, 1 do 
		local LK_key_data = LK.keys[i]
		if LK_key_data.ACTIVE and LK.IHaveKey(LK_key_data.OWN) then 
			if LK.debug then LK.msg(LK_White,"Issuing key " ..  LK_key_data.ID .. " to " .. towho) end
				local x = tonumber(LK_key_data.ID)
				local keyresult = Keychain.giveuserkey(towho, LK_key_data.ID, LK.Callback)
				if LK.debug and keyresult then print("key result: "..keyresult) end
				if not LK.InUserList(towho) then -- User is new.  Put them in the list.
					LK.msg(LK_White,"User added to Key List:"..towho)
					table.insert(LK.Users,towho) -- Add the user to the saved user list.
					LK.Server_Command(nil,{"addkey", towho}) -- Update the database on server
					LK.Users_loaded	= false
				end
		end
	end
end

-- Give Owner keys -------------------------------------------------
function LK.Give_Owner(towho)
towho = string.lower(towho)
local found = 0
	for i = 1, # LK.keys, 1 do 
		local LK_key_data = LK.keys[i]
		--if LK.InNoKeyList(LK_key_data.ID) then print(LK_key_data.ID.." is in the list") end
		if (not LK.InNoKeyList(LK_key_data.ID) and LK_key_data.ID ~= LK.capship) and LK_key_data.ACTIVE and not LK_key_data.OWN then 
			--LK.msg(LK_White,LK_key_data.ID.." Giving owner key to: "..towho)
			Keychain.giveownerkey(towho, LK_key_data.ID, LK.Callback) --Issue the owner key
			if  not LK.InOwnerList(towho) then -- User is new.  Put them in the list.
				LK.msg(LK_White,"New owner to add:"..towho)
				table.insert(LK.Owners,towho) -- Add the user to the saved Owners list.
				LK.Server_Command(nil,{"addown", towho}) -- Update the database
				LK.Owners_loaded	= false
			end
		end
	end
end

-- Add a key to the restricted list---------------------------------------
function LK.Add_NoKey(num)
	num = string.lower(num)
	LK.Server_Command(nil,{"addnokey", num}) -- Update the database on server
	LK.Timer2:SetTimeout(2000,LK.Load_NoKeys) -- 2 sec later load NoKeys
end

-- remove a key to the restricted list---------------------------------------
function LK.Rem_NoKey(num)
	num = string.lower(num)
	LK.Server_Command(nil,{"remnokey", num}) -- Update the database on server
	LK.Timer2:SetTimeout(2000,LK.Load_NoKeys) -- 2 sec later load NoKeys
end

-- Remove User from the list -------------------------------------------------
function LK.Remove(towho)
	towho = string.lower(towho)
	for k,j in pairs(LK.Users) do -- see if the user is in the list.
		if (j == towho) then 
			LK.msg(LK_White,"Removing "..towho.." From the Users list")
			table.remove(LK.Users,k); 
		end
	end		
	for k,j in pairs(LK.Owners) do -- see if the owners is in the list.
		if (j == towho) then 
			LK.msg(LK_White,"Removing "..towho.." From the Owners list")
			table.remove(LK.Owners,k); 
		end
	end
LK.Server_Command(nil,{"delkey", towho}) -- Update the database
LK.Server_Command(nil,{"delown", towho}) -- Update the database
LK.Timer3:SetTimeout(1000,LK.Load_Owner) -- 1 sec later load owner keys
LK.Timer4:SetTimeout(3000,LK.Load_User) -- 3 sec later load user keys
end

-- Add a command to the to-do list---------------------------------------
function LK.Add_Command(towho)
	towho = string.lower(towho)
	LK.Server_Command(nil,{"addcmd", towho}) -- Update the database on server
	LK.Timer2:SetTimeout(2000,LK.Load_ToDo) -- 2 sec later load NoKeys
end

-- Remove a command from the to-do list---------------------------------------
function LK.Remove_Command(data)
data = tonumber(data)
if data > #LK.Cmds then return end
local cmd = LK.Cmds[data]
LK.Server_Command(nil,{"delcmd", cmd}) -- Update the database on server
LK.Timer1:SetTimeout(2000,LK.Load_ToDo) -- 2 sec later load ToDo list.
end

-- Revoke keys --------------------------------------------------------------
function LK.Revoke(towho)
towho = string.lower(towho)

for i = 1, # LK.keys, 1 do 
	local LK_key_data = LK.keys[i]
	if LK_key_data.ACTIVE and not LK_key_data.OWN then 
		LK.msg(LK_White,"Revoking keys " ..  LK_key_data.ID .. " from " .. towho)
		Keychain.revokekey(towho, LK_key_data.ID, LK.Callback)
	end
end
for k,j in pairs(LK.Users) do -- see if the user is in the list.
	if (j == towho) then table.remove(LK.Users,k); break; end
end		
for k,j in pairs(LK.Owners) do -- see if the owners is in the list.
	if (j == towho) then table.remove(LK.Owners,k); break; end
end		
LK.Server_Command(nil,{"delkey", towho}) -- Update the database
LK.Server_Command(nil,{"delown", towho}) -- Update the database
LK.Timer3:SetTimeout(1000,LK.Load_Owner) -- 1 sec later load owner keys
LK.Timer4:SetTimeout(3000,LK.Load_User) -- 3 sec later load user keys
end

-- Guild ----------------------------------------------------------------------
function LK.Guild()
LK.msg(LK_White,"Issuing valid keys to all logged-on guild members...") 
for i=1,GetNumGuildMembers() do
  local id, rank, name = GetGuildMemberInfo(i)
	LK.msg(LK_Grey,"Issuing keys to " .. name)
	LK.Give_User(name)
	end
end

-- Saved List -----------------------------------------------------------------
function LK.Saved()
LK.msg(LK_White,"Issuing valid keys to all People in stored list...") 
	for k,j in pairs(LK.Users) do -- Go through the list.
		LK.Give_User(j)
	end
	LK.msg(LK_Grey,"")
	for k,j in pairs(LK.Owners) do -- Go through the list.
		LK.Give_Owner(j)
	end
end

-- Show Saved List ------------------------------------------------------------
function LK.Show_Saved()
	local cols = 4
	local myoutput = LK_White.."User Keys to: \n"..LK_Grey
	for k,j in pairs(LK.Users) do
		myoutput = myoutput..j.."\n"
	end
	myoutput = myoutput..LK_White.."\nOwner Keys to: \n"..LK_Grey
	for k,j in pairs(LK.Owners) do
		myoutput = myoutput..j.."\n"
	end
	LK.ui:ShowOutput(myoutput)
end

-- List Bad Keys ------------------------------------------------------------
function LK.List_NoKeys()
	LK.msg(LK_White,"Keys to NOT issue to anyone:")
	for k,j in pairs(LK.NoKeys) do
		LK.msg(LK_Grey,j)
	end
end
	
	-- Give User keys for capship -------------------------------------------------
function LK.Capship(towho)
	LK.msg(LK_White,"Giving your caphip keys to: "..towho)
	for k,j in pairs(LK.NoKeys) do
		if LK.IHaveKey(j) then 
			LK.msg(LK_Grey,"I own key "..j.." so issuing it...")
			Keychain.giveuserkey(towho, j, LK.Callback)
		end
	end
end

-- Revoke User keys for capship -------------------------------------------------
function LK.Capship_Revoke(towho)
	LK.msg(LK_White,"Revoking your caphip keys from: "..towho)
	for k,j in pairs(LK.NoKeys) do
		if LK.IHaveKey(j) then 
			LK.msg(LK_Grey,"I own key "..j.." so revoking it...")
			Keychain.revokekey(towho, j, LK.Callback)
		end
	end
end

-- Delete a key(s) -------------------------------------------------
function LK.Deletekey(keynum)
	for i = 1, # LK.keys, 1 do 
		local LK_key_data = LK.keys[i]
		if keynum == LK_key_data.ID then
			LK.msg(LK_White,"Deleting key " ..  LK_key_data.ID .. " Named: " .. LK_key_data.DESC)
			Keychain.deletekey(LK_key_data.ID, LK_key_data.DESC, LK.Callback)
			break;
		end
	end
	LK.Keys_loaded = false
end

-- Revoke all user keys from a key------------------------------------------
function LK.RevokeAll(err,result)
	if (LK.GetKeyIndex(LK.Key)<0) then
  	LK.msg(LK_White,"No such key.")
  	return
	else
		print("Revoking all users from key: "..LK.Key)
		local i = LK.GetKeyIndex(LK.Key)
		LK_keyid, LK_description, LK_owner, LK_timestamp, LK_access, LK_possessors, LK_active = GetKeyInfo(tonumber(LK.GetKeyIndex(LK.Key)))
		if not LK.IHaveKey(LK_owner) then
  		LK.msg(LK_White,"You do not have the owner key.")
  		return end
		for j = 0, #LK_possessors, 1 do 
			local player = GetPlayerName(LK_possessors[j])
  		LK.msg(LK_White,player.." Revoked...")
			Keychain.revokekey(player, LK.Key, LK.Callback)
		end
	end
end

-- list Key Users -------------------------------
function LK.ListKeyUsers(err,result)
	LK_keyid, LK_description, LK_owner, LK_timestamp, LK_access, LK_possessors, LK_active = GetKeyInfo(tonumber(LK.GetKeyIndex(LK.Key)))
	local myoutput = LK_White.."Players with this key:\n"..LK_Grey
	for j = 1, # LK_possessors, 1 do 
		local player = GetPlayerName(LK_possessors[j])
		table.insert(LK.data,player)
	end
	table.sort(LK.data)
	local i = 1
	local cols = 4
	for j = 1, # LK.data, 1 do 
		myoutput = myoutput..LK.data[j].."\n"
	end
	LK.ui:ShowOutput(myoutput)
end

-- Get key data for other functions-----------------------------
function LK.KeyData(temp,cbname)
	if (LK.GetKeyIndex(temp)<0) then
  	LK.msg(LK_White,"No such key.")
  	return false
	else
		LK.Key = temp
		LK.data = {}
		Keychain.list(temp, cbname)
	end
return true
end

-- function to show what commands are queued up.
function LK.ListToDo()
	if #LK.Cmds > 0 then
		LK.msg(LK_White,"Commands in your ToDo list:")
		for k,j in pairs(LK.Cmds) do
			LK.msg(LK_Grey,k.."\t"..j)
		end
		LK.msg(LK_White,"To Perform these commands use '/keys -cmds'")
	end
end

-- function to execute what commands are queued up.
function LK.DoToDo()
	LK.msg(LK_White,"Executing Commands:")
	for k,j in pairs(LK.Cmds) do
		gkinterface.GKProcessCommand(j)
	end
end

-- Info display .---------Stuff I'm Playing with----------------
function LK.Info()
--	LK.msg(LK_White,"XX-SystemID: ".. GetCurrentSystemid().."    SectorID: "..GetCurrentSectorid())
--	LK.msg(LK_White,"Short Location: "..ShortLocationStr(GetCurrentSectorid()))
--	print("Ship purchase color is: "..GetShipPurchaseColor())
	LK.msg(LK_White,"Character Name is: "..GetPlayerName(GetCharacterID()))
--LK.junk = gkinterface.GKProcessCommand("bind")
--local k = 1
--for k = 1, 63000 do
	--LK.junk = GetStationSellableInventoryInfoByID(k) -- -> {bool is_ammorepair, string type, int unitcost, int price, string longdesc, string desc, string name, bool locallyproduced, neededlevels = {string l1 .. l5}, int itemid, string icon } :: get sellable inventory info by id ...
--	LK.junk = GetStationSellableInventoryInfoByID(1833)
--dofile(LK.PlayerName..".dat")
-- 	for k,j in pairs(LK.Binds) do
-- 		--print("keytobind: "..j[1].."    j:"..j[2])
-- 		local str = "bind "..j[1].." "..j[2]
-- 		--print(str)
-- 		gkinterface.GKProcessCommand(str)
-- 	end
	--LK.Key_Verified()
	--LK.Sector_Verified()
	--for i=0, 199 do
		--if SystemNames[i] then
			--print("{"..i..",\""..SystemNames[i].."\"},")
		--end
	--end
end

-- Private Chat Processing -------------------------------------------------
function LK.Private_Chat(event,data)
		if(string.find(data.msg, "For Great Justice!")) then -- Thanks to Azurea for the code for this.
      local NPC_data = {}
      for k, v in data.msg:gmatch("\{(.-),(.-)\}") do
          if v ~= "undefined" then
              NPC_data[k] = v
              LK.msg(LK_White,k.." "..v)
          end
      end
      if NPC_data.dest then
          LK.msg(LK_White,"Destination: "..ShortLocationStr(tonumber(NPC_data.dest)))
      end
      if NPC_data.mission_type then
          LK.msg(LK_White,"Mission Type: "..tostring(NPC_data.mission_type))
      end
      if NPC_data.shield_recharge_rate then
          LK.msg(LK_White,"Shield Recharge: "..tostring(NPC_data.shield_recharge_rate))
      end
      if NPC_data.shield_max_strength then
          LK.msg(LK_White,"Shield Max Strength: "..tostring(NPC_data.shield_max_strength))
      end
		else -- You are talking to a real person
		  LK.msg(LK_White,"->"..rgbtohex(FactionColor_RGB[data.faction])..data.name..LK_White.."<- "..LK_Red..data.msg)
		end
end

-- Scan NPC -------------------------------------------------
function LK.ScanNPC()
	local name, health, dist, guild, ship
	name, health, dist, LK.Target_FactionID, guild, ship = GetTargetInfo()
	if name == nil then return end
  SendChat("wtf", "PRIVATE", name)
end

-- ReloadInterface -------------------------------------------------
function LK.Reload()
	LK.msg(LK_White,"Reloading interface....")
	ReloadInterface()
end

-- Load ToDo list -------------------------------
function LK.Load_ToDo()
	LK.Server_Command(nil,{"listcmds"}) -- Talk the database
end

-- Load Owner Keys from the server ---------------------------
function LK.Load_Owner()
	LK.Server_Command(nil,{"listown"}) -- Talk to the database
end

-- Load User Keys from the server ---------------------------
function LK.Load_User()
	LK.Server_Command(nil,{"listkeys"}) -- Talk to the database
end

-- Load NoKeys from the server ---------------------------
function LK.Load_NoKeys()
	LK.Server_Command(nil,{"listnokeys"}) -- Talk to the database
end

-- Init KEYS and  -------------------------------------------------
function LK.Init()
	UnregisterEvent(LK.Init, "ENTERED_STATION") -- Only init once....
	UnregisterEvent(LK.Init, "SHIP_SPAWN_CINEMATIC_FINISHED") -- Only init once....
	LK.Get_Keys()
	LK.PlayerName	= string.lower(GetPlayerName(GetCharacterID()))
	LK.msg(LK_White,"Keys Version: ".. LK.version.."   Character Name is: "..LK.PlayerName)
	LK.capship  = gkini.ReadString("keys","capshipkey" ,"None")
	LK.password = gkini.ReadString("keys","password" ,"None")
	LK.Timer1:SetTimeout(1000,LK.Load_ToDo) -- 1 sec later load ToDo list.
	LK.Timer2:SetTimeout(3000,LK.Load_NoKeys) -- 3 sec later load NoKeys
	LK.Timer3:SetTimeout(5000,LK.Load_Owner) -- 5 sec later load owner keys
	LK.Timer4:SetTimeout(7000,LK.Load_User) -- 7 sec later load user keys
	LK.Timer5:SetTimeout(20000,LK.Key_Status) -- 20 sec later show key status
	if LK.tryITAN then SendChat("#giveall", "PRIVATE", "IRC_") end
end
--end

-- Main -------------------------------------------------
function LK.Commands(_,data) -- Process the commands that were given.
	--if not LK.Users_loaded then LK.Load_Data() end -- Load the keys from the database
	
	if not data then
		LK.ui:ShowHelp(); return
	else
		local command = string.lower(data[1])
		if (command == "-reload") then LK.Reload(); return end

		if not LK.Keys_loaded then LK.Get_Keys() end
		if (command == "-setkey") then
			if (data[2]) then
				local input_arg = data[2]
				LK.capship = input_arg
				gkini.WriteString("keys", "capshipkey", input_arg)
				LK.msg(LK_White,"Capship key has been set.")
				LK.Add_NoKey(input_arg)
				end
		elseif (command == "-setpass") then
			if (data[2]) then
				local input_arg = data[2]
				LK.password = input_arg
				gkini.WriteString("keys", "password", input_arg)
				LK.msg(LK_White,"Password for server has been set.")
			end
		elseif (command == "-list") then	LK.Show_Keys(0)
		elseif (command == "-ver") or (command == "-version") then 
			LK.msg(LK_White,"Keys Version: " .. LK.version)
		elseif (command == "-info") then LK.Info()
		elseif (command == "-addown") then LK.Give_Owner(data[2])
		elseif (command == "-addnokey") then LK.Add_NoKey(data[2])
		elseif (command == "-addcmd") then LK.Add_Command(data[2])
		elseif (command == "-listown") then LK.Show_Keys(2)
		elseif (command == "-listnokeys") then LK.List_NoKeys()
		elseif (command == "-saved") then LK.Saved()
		elseif (command == "-cmds") then LK.DoToDo()
		elseif (command == "-listcmds") then LK.ListToDo()
		elseif (command == "-debug") then LK.debugtoggle()
		elseif (command == "-get") then LK.Get_Keys()
		elseif (command == "-purge") then LK.Purge()
		elseif (command == "-show") then LK.Show_Saved()
		elseif (command == "-listuser") then	LK.Show_Keys(1)
		elseif (command == "-listkey") then LK.KeyData(data[2],LK.ListKeyUsers)
		elseif (command == "-guild") then LK.Guild()
		elseif (command == "-revoke") then LK.Revoke(data[2])
		elseif (command == "-revokeall") then LK.KeyData(data[2],LK.RevokeAll)
		elseif (command == "-remuser") then LK.Remove(data[2])
		elseif (command == "-remcmd") then LK.Remove_Command(data[2])
		elseif (command == "-remnokey") then LK.Rem_NoKey(data[2])
		elseif (command == "-status") then LK.Key_Status()
		elseif (command == "-aadmin") then LK.Server_Command(nil,{"aadmin",data[2],data[3]}) -- Talk to the database
		elseif (command == "-init") then LK.Init()
		elseif (command == "-capship") then
			if LK.capship then
			local i = 2
			while data[i] ~= nil  do
				LK.Capship(data[i]) -- Process all command line user names
				i = i+1
				end
			end
		elseif (command == "-caprevoke") then
			if LK.capship then
			LK.Capship_Revoke(data[2]); return end
		elseif (command == "-delete") then
			local i = 2
			while data[i] ~= nil  do
				LK.Deletekey(data[i]) -- Process all command line user names
				i = i+1
			end
			
		elseif (command == "-help") then
			LK.ui:ShowHelp(); return
			elseif (command == "-add") or (command == "-adduser")then
			local i = 2
			while data[i] ~= nil  do
				LK.Give_User(data[i])
				i = i+1
			end
			
		else
			LK.ui:ShowHelp()
		end
	end
end

----------------------------------------------------------------------
-- Commands the user can use
RegisterUserCommand("keys",LK.Commands);
RegisterUserCommand("scannpc",LK.ScanNPC);
RegisterUserCommand("keystat",LK.Key_Status);
RegisterUserCommand("ks",LK.Key_Status);
RegisterUserCommand("ki",LK.Info);
RegisterUserCommand("keysui", LK.Toggle);

-- event handler --
function LK.OnEvent(event, data) --This section not used yet.
	if LK.debug then 
		print("Event Trigger: "..event) 
		print("Type of data: "..type(data))
	end
end
 
-- register events 
UnregisterEvent(chatreceiver, "CHAT_MSG_PRIVATE") --Unregister VO's private chat function
RegisterEvent(LK.Private_Chat, "CHAT_MSG_PRIVATE")
RegisterEvent(LK.Get_Keys, "KEYADDED") -- Update the data after getting a new key.
RegisterEvent(LK.Init, "ENTERED_STATION")
RegisterEvent(LK.Init, "SHIP_SPAWN_CINEMATIC_FINISHED")
RegisterEvent(LK.Key_Verified, "SECTOR_CHANGED")
RegisterEvent(LK.Key_Verified, "NAVROUTE_CHANGED")
--RegisterEvent(LK.Sector_Verified, "NAVROUTE_CHANGED")
